/*
Aleksandra Wjcik, Album: 192846, Grupa: K1-ISIII2
Biblioteka standardowa : strumienie cin, cout, cerr, clog

Predefiniowane strumienie cin, cout, cerr oraz clog s obiektami biblioteki <iostrem>,
ktre umoliwiaj komunikacj przez standardowe wejcie lub wyjcie:

cin - standardowe wejcie, z reguy jest to klawiatura 
cout - standardowe wyjcie, z reguy jest to ekran 
cerr - standardowe wyjcie dla bdw, z reguy ekran
clog - w peni buforowana wersja cerr 

Istniej dwie grupy narzdzi umoliwiajcych operacje wejcia / wyjcia), kade dla dwch rodzajw danych wejciowych:

- Dla danych sformatowanych (interpretowane jako wartoci jednego z typw danych) 
  Operacje wejcia ekstrahuj z sekwencji znakw dane odpowiednich typw,
  s wykonywane za pomoc przecionego operatora wejcia >>
  Operacje wyjcia realizowanie z za pomoc operatora <<
- Dane niesforamtowane (cig bitw)
  Metody klasy istream mog  pobiera ustalon ilo danych z wejcia (get, getline, peek, read, readsome),
  manipulowa wskanikiem (ignore, seekg, tellg, unget) albo odczyta informacj o ostatniej operacji (gcount).
  Metody klasy ostream wypisujce sekwencje danych na wyjcie to put lub write.  

  CIN
  Operator >> przyjmuje wszystkie znaki. Naley wic uwaa i w miar moliwoci zabezpieczy kod przed tym,
  e uytkownik moe prbowa wprowadzi dane innego typu, ni zostanie  poproszony.
  Cin wczytuje sekwencj dopki nie napotka biaego znaku. Jeli dalej zostay wprowadzone jeszcze jakie inne znaki,
  to pozostaj one w strumieniu do czasu, a nie zostan z niego pobrane. Dlatego warto po kadym uyciu cin wywoa
  metod ignore();
  COUT
  Strumie cout jest domylnie buforowany liniowo (ale mona to zmieni), co znaczy,
  e dopiero po wysaniu do niego caej linii wraz z jej kocem (lub po zakoczeniu programu) zawarto buforw jest faktycznie wysyana.
  Operacje flush zmuszaj buforowane wyjcie do pozbycia si wszystkich danych. Wywoanie: cout.flush()
  CERR i CLOG
  Do wypisywania informacji o bdzie nalezy stosowa cerr, a nie cout, gdy w systemie Unix mona przekierowa strumie bdu (np. do pliku).
  Aby przekierowa strumie bdw w powokach bazujcych na sh naley uy znakw 2>.
  Clog suy do wypisywania logw na standardowym wyjciu.

*/

#include <iostream>
#include <string>
#include <limits>

#define MAX 20 

using namespace std;

int main()
{	
	/**************************************************************************
	Wczytywanie danych do zmiennej typu int za pomoc operatora >>
	**************************************************************************/

	int number;
	bool bad_input; // deklaracja flagi zabezpieczajcej kod

	do
	{
		cout << "Podaj ulubiona liczbe:" << endl;
		bad_input = 0; // ustawia flag na "stan poprawny"
		cin >> number; // wczytanie danych ze strumienia do zmiennej typu int
		if(!cin) // cin jest w bdnym stanie, gdy wprowadzone dane nie byy danego typu
		{
			bad_input = 1; // ustawia flag na "stan bdny"
			cin.clear(); // zmienia stan strumienia na poprawny
			cin.ignore(std::numeric_limits<streamsize>::max(),'\n'); // usuwa bdne dane ze strumienia
			cerr << "err: wczytywanie int: To nie liczba!" << endl; // komunikat o bdzie
		}
	}while(bad_input); // gdy wartos flagi wskazuje na "stan bdny", powtarza procedur
	cin.ignore(numeric_limits<streamsize>::max(), '\n'); // usuwa ze strumienia pozosae dane

	/*************************************************************************
	Wczytanie danych do zmiennej typu string za pomoc operatora >>
	*************************************************************************/

	string name;
 	cout<< "Podaj imie:" << endl;	
	cin >> name; //wczytanie danych do zmiennej typu string, a do napotkania pierwszego biaego znaku
	cin.ignore(numeric_limits<streamsize>::max(), '\n'); // usuwa ze strumienia pozostae dane

	/*************************************************************************
	Wczytanie pojedynczego znaku za pomoc operatora >>
	*************************************************************************/

	char letter;
	cout << "Podaj pierwsza litere nazwiska:" << endl;	
	cin >> letter; // wczytanie danych do zmiennej typu char, pobiera ze strumienia tylko jeden znak
	cin.ignore(numeric_limits<streamsize>::max(), '\n'); // usuwa ze strumienia pozostae dane

	/***************************************************************************
	Wczytanie caej linii za pomoc metody getline()
	***************************************************************************/

	char movie[64];
	cout <<"Podaj tytul filmu:" << endl;	
	cin.getline(movie, sizeof(movie)); // wczytuje ca lini do acucha znakowgo o odpowiednio dobranej wielkoci

	/*****************************************************************************
	Wypisywanie danych rnego typu za pomoc operatora <<
	*****************************************************************************/

	cout << name << " " << letter << " lubi liczbe " << number << " oraz film pt. " << movie << "." << endl;

	/*****************************************************************************
	Testowanie metod get() i put() do wczytywania i wypisywania pojedynczego znaku
	*****************************************************************************/

	char single;
	cout << "Podaj literke: " << endl;
	cin.get(single); // wczytuje pojedynczy znak do zmiennej znakowej, kolejne dane wejciowe pozostaj w strumieniu
	cin.ignore(numeric_limits<int>::max(), '\n'); // usuwa kolejne dane wejciowe ze stumienia
	cout << "Tyle znakow zignorowalem: " <<cin.gcount() << endl; // wywietla ilo usunitych danych
	cout << "Podales: ";
	cout.put(single); // wypisuje pojedynczy znak
	cout << endl;

	/***************************************************************************************
	Testowanie podobiestw i rnic pomidzy metodami get() i peek() oraz putback() i unget()
	***************************************************************************************/

	char c1, c2, c3;
	char str[64];
	cout << "podaj slowo ";
	c1 = cin.get(); // wczytuje do c1 pierwszy znak podanej sekwencji i usuwa go ze strumienia
	c2 = cin.get(); // wczytuje do c2 drugi znak podanej sekwencji i usuwa go ze strumienia
	c3 = cin.peek(); // wczytuje do c3 trzeci znak podanej sekwencji nie usuwajc go ze strumienia
	cout << "Pierwsza literka to: " << c1 << endl;
	cout << "Druga literka to: " << c2 << endl;
	cout << "Trzecia literka to: " << c3 << endl;
	cin.putback(c2); // wprowadza spowrotem do strumienia znak zapisany w zmiennej c2
	cin.unget(); // wprowadza spowrotem do strumienia kolejny usunity znak
	cin >> str; // pobiera ze strumienia ca sekwencj do zmiennej str
	cout << "Cale slowo to: " << str << endl;
	cin.ignore(numeric_limits<int>::max(), '\n'); // usuwa ze strumienia pozostae dane

	/****************************************************************************
	Zastosowanie metod cout.width() i cout.fill() oraz flag left, right
	do formatowania tekstu wypisywanego za pomoc operatora <<
	- metoda cout.width(int) - ustawia szeroko (w znakach) wywietlanego tekstu,
	  domylnie jest ona rwna szerokosci wywietlanego tekstu
	  modyfikuje tylko pierwsze pole w linii
	- flagi left i right okrelaj pooenie czytanych ze strumienia danych
	  domylnie ustawiona right, gdy si j zmieni, ustawienie te zostanie zapamitane
	  a do kolejnej zmiany
	- metoda cout.fill(char) - ustawia znak wypenienia pola o szerokoci zadanej przez width(),
	  domylnie ustawiony ' ', gdy sie go zmieni, ustawienie to zosatnie zapamitane
	  a do kolejnej zmiany
	****************************************************************************/

	string chapter("Rozdzial");
	string bibliography ("Bibliografia");
	int chapterSize = chapter.length();
	int bibliographySize = bibliography.length();
	cout.fill('.'); // ustawienie znaku wypenienia na '.'

	for(int i = 1; i < 10; i++)
	{
		cout << chapter << i;
		cout.width(MAX - chapterSize - 1); // ustawienie szerokoci pola tekstowego
		cout << i << endl;
	}
	cout << bibliography;
	cout.width(MAX - bibliographySize); // zmiana szerokoci pola tekstowego
	cout << 11 << endl;
	cout.fill(' '); // zmiana znaku wypenienia
	cout.width(MAX - 2); // zmiana szerokoci pola tekstowego
	cout << left << "KONIEC" << "XX" << endl; // przesunicie danych wystpujcych bezporednio po << w lewo

	for (int i=3; i<10; i++)
	{
		cout << "Sto:" ;
		cout.width(i); // kadorazowo zmienia szeroko pola dla wywietlenia liczby 100
		if(i < 8)
			cout << 100 << "." << endl; //liczba 100 wywietlana po lewej stronie pola
		else if( i == 8)
			cout << right << 100 << "." << endl; // liczba 100 wywietlana po prawej stronie pola 
		else
			cout << 100 << "." << endl; // flaga wci ustawiona na right
	}

	/**********************************************************************************************
	Testowanie metody cout.precision(int n), okrelajcej dokadno wyswietlania czci uamkowych
	**********************************************************************************************/

	float num = 1.23456;
	cout << num << endl; // domyslnie n = 6

	for (int i=2; i<7; i++) 
	{
		cout.precision(i); // zmiana precyzji od n = 2 do n = 6
		cout << num << endl;
	}

	/******************************************************************************************
	Testowanie metod cin.read() i cout.write()
	******************************************************************************************/

	char text2 [3];
	cout << "Podaj slowo na 3 litery:" << endl;	
	cin.read(text2, sizeof(text2)); // wczytuje do acucha znakowego okrelon ilo znakw
	cout.write(text2, sizeof(text2)); // wypisuje okrelon ilo znakw z acucha znakowego
	cout << endl;

	/*****************************************************************************************
	Testowanie cerr i clog
	*****************************************************************************************/

	char tab [3];
	char x = 'a';
	for(int i = 0; i<10; i++)
	{
		if(i>2) cerr << "err: testowanie cerr: Wyjscie poza zakres!)" << endl;
		else tab [i] = x;
	}
	clog << "Koncze dzialanie programu" << endl;

    return 0;
}
